#include <pthread.h>
#include "Avancement.h"

static int Compteur=0;

int HandleCore::ReachCore(Avancement *av)
{
	return 1;
}

Avancement::Avancement()
{
	mHandleCore = 0;
	mNStage=mNStatement=mStage=mStatement=0;
	mState=XMST_FREE;
	mStageName=NULL;
}

Avancement::Avancement(Avancement *av)
{
	mHandleCore = av->mHandleCore;
	mNStage = av->mNStage;
	mNStatement = av->mNStatement;
	mStage = av->mStage;
	mState = av->mState;
	mStageName = av->mStageName;
}


HandleCore *&Avancement::Handle()
{
	return mHandleCore;
}

void *filet(void *av)
{
	Avancement *pAv = (Avancement *)av;
	pAv->Handle()->ReachCore(pAv);
	return NULL;
}

int Avancement::ReachCore()
{
	printf("XM_MSG: 1. Appel Callback noyau [%d]\n", Compteur);
	printf("XM_MSG: 2. Appel Callback noyau [%d]\n", Compteur);
	if (!mHandleCore) return -1;
	mHandleCore->ReachCore(this);
	printf("XM_MSG: Fin Callback noyau [%d]\n", Compteur);
	return 0;
}

int &Avancement::NStage()
{
	return mNStage;
}

int &Avancement::NStatement()
{
	return mNStatement;
}

int &Avancement::Stage()
{
	return mStage;
}

int &Avancement::Statement()
{
	return mStatement;
}

int &Avancement::State()
{
	return (int &)mState;
}

int Avancement::IsVoid()
{
	return mState==XMST_VOID;
}

int Avancement::IsBusy()
{
	return mState==XMST_BUSY;
}

int Avancement::IsFree()
{
	if (mState==XMST_FREE) {mState=XMST_BUSY;return 1;}
	return 0;
}

int Avancement::SetBusy()
{
	if (mState==XMST_BUSY) {return 0;}
	mState=XMST_BUSY;
	return 1;
}

int Avancement::SetVoid()
{
	if (mState==XMST_BUSY) {return 0;}
	mState=XMST_VOID;
	return 1;
}

int Avancement::SetFree()
{
	mState=XMST_FREE;
	return 1;
}

double Avancement::Total()
{
	return (mNStage*mNStatement);
}

char *&Avancement::StageName()
{
	return mStageName;
}