#ifndef CFILE_H
#define CFILE_H

typedef struct SFile
{
        void *PInfo;
        struct SFile *Suiv;
}SFile;

template <class T> class CFile
{
        protected:
        	SFile *mCourant,*mTete, *Ptr[2], *mCourantNP, *mTeteNP;
        public:
        	CFile(){ mCourant=NULL;mTete=NULL;};
        	CFile(CFile &file);
        	void Take(T &info);
        	void Enfiler(T info);
        	void Defiler(T &info);
        	void GetTete(T &Info);
        	void AllerTete(T &Info);
        	int  Occurrence();
        	int  Vide(){return (mCourant==NULL);};
        	CFile <T> &operator= (CFile <T>&file);
        	int  VideNP(){return (mCourantNP==NULL);};
        	int GetCount();
        	void InitNP();
        	void DefilerNP(T *&info);
        	~CFile();
};

template <class T> CFile<T>::CFile(CFile &file)
{
        SFile *Ptr=file.mTete,*P,*M=NULL;
        T *PtrT;
        mCourant=NULL;
        while (Ptr)
        {
                P=new SFile;
                PtrT=(T *)new T;
                *PtrT=*((T *)(Ptr->PInfo));
                P->PInfo=(void *)(PtrT);
                P->Suiv=NULL;
                if (M) M->Suiv=P; else mTete=P;
                Ptr=Ptr->Suiv;
                M=P;
        }
        mCourantNP=mCourant=P;
}


template <class T> void CFile<T>::Enfiler(T info)
{
       SFile *P;
       T *ptr=new T;
       P=mCourant;
       mCourant=new SFile;
       mCourant->Suiv=NULL;
       if (P) P->Suiv=mCourant;else mTete=mCourant;
       *ptr=info;
       mCourant->PInfo=(void *)ptr;
}

template <class T> void CFile<T>::Defiler(T &info)
{
        if (mTete)
        {
                SFile *P;
                info=*((T*)(mTete->PInfo));
                P=mTete;  mTete=mTete->Suiv;
        	delete P->PInfo; delete P;
        	if (!mTete) mCourant=NULL;
        }
        
}

template <class T> void CFile<T>::Take(T &info)
{
        if (mTete)
        {
                SFile *P;
                info=*((T*)(mTete->PInfo));
                P=mTete;  Ptr[0]=mTete=mTete->Suiv;
        	delete P->PInfo; delete P;
        	if (!mTete) Ptr[1]=mCourant=NULL;
        }
}
 

template <class T> void CFile<T>::AllerTete(T &Info)
{
        mTete = Ptr[0];
        mCourant = Ptr[1];
        if (mTete) Info=*((T*)(mTete->PInfo));
}
  
template <class T> void CFile<T>::GetTete(T &Info)
{
        if (mTete) Info=*((T*)(mTete->PInfo));
} 

template <class T> int CFile<T>::Occurrence()
{
        int Nbre=0;
        SFile *P = mTete;
        while (P)
        {
                P = P->Suiv;
                Nbre++;
        }
        return Nbre;                        
}

template <class T> CFile <T> &CFile<T>::operator= (CFile <T> &file)
{
        CFile F(file);
        return F;
}

template <class T> void CFile<T>::InitNP()
{
	mCourantNP = mTeteNP = mTete;
}

template <class T> int CFile<T>::GetCount()
{
	SFile *Ptr;
	int n=0;
	for (Ptr = mTete; Ptr; n++) Ptr = Ptr->Suiv;
	return n;
}

template <class T> void CFile<T>::DefilerNP(T *&info)
{
        if (mCourantNP)
        {
                info=(T*)(mCourantNP->PInfo);
                mCourantNP=mCourantNP->Suiv;
        }
        
}

template <class T> CFile<T>::~CFile()
{
        SFile *P;
        mCourant=mTete;
        while (mCourant)
        {
                P=mCourant;
                mCourant=mCourant->Suiv;
        	delete P->PInfo; delete P;
        }
}

#endif
