#ifndef FUNOPCOMPARAISON_H
#define FUNOPCOMPARAISON_H
#include <stdio.h>
#include <type.h>

class CEvaluator;
CEvaluator ***GetTABFonctionComparateur(TOperator top);
void ReleaseTABComparateur(CEvaluator ***&pEvaluator);

/***********************************************/
/* Class de base pour effectuer des oprations */
/***********************************************/
/***********************************************/

class CEvaluator
{
public:
	virtual bool Evaluate(void *valx, void *valy){};
};

/***********************************************/
/***********************************************/


template <class X, class Y> class CComparator: public CEvaluator
{
	private:
        	bool (*mfCalc)(X ,  Y, void *, void *);
        public:
        	CComparator();
        	CComparator(bool (*fcalc)(X, Y, void *, void *));
        	bool Evaluate(void *valx, void *valy);
        	~CComparator();
};

template <class X, class Y> CComparator<X, Y>::CComparator():
				CEvaluator(&Compare)
{
	mfCalc = NULL;
}

template <class X, class Y> CComparator<X, Y>::CComparator(bool (*fcalc)(X, Y, void *, void *))
{
	mfCalc = fcalc;
}

template <class X, class Y> bool CComparator<X, Y>::Evaluate(void *valx, void *valy)
{
	X x;
	Y y;
	return ((*mfCalc)(x, y, valx, valy));
}

template <class X, class Y> CComparator<X, Y>::~CComparator()
{
}

#endif  /* FUNOPCOMPARAISON_H */