#ifndef IXMOBJECTX_H
#define IXMOBJECTX_H
#include "head.h"
#include "Liste.h"
#include "intervalle.h"
#include "math.h"
#include "vecteur.h"
#include "variable.h"
#include "matrice.h"
#include "whole.h"
#include "plot.h"

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer une variable						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMVariable* MakeVariable(char *vals, char *nom, char **var, TYPE *pt);			   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer une fonction						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMFonction* MakeFonction(char *exp, char *nom, char **Var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer une matrice						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMMatrice* MakeMatrice(XMWhole *vect, char *nom, char **Var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un vecteur						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMVecteur* MakeVecteur(CList<XMObjectX *> *lvar, char *nom, char **var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un plot						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMPlot* MakePlot(XMWhole *whole, char *nom, char **var, TYPE *val=NULL);		   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un intervalle						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMIntervalle* MakeIntervalle(CList<XMObjectX *> *lvar, char *nom, char **var, TYPE *val=NULL);//
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un ensemble						   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMWhole* MakeWhole(CList<XMObjectX *> *lob, char *nom, char **var, TYPE *val=NULL);	   //
/////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////////////////////
// Fonction permettant de crer un head							   //
/////////////////////////////////////////////////////////////////////////////////////////////
XMHead* MakeHead(CList<XMObjectX *> *lob, char *nom, char **var, TYPE *val=NULL);	   //
/////////////////////////////////////////////////////////////////////////////////////////////

#endif IXMOBJECTX_H