#include <stdio.h>
#ifndef CCALCULATOR_H
#define CCALCULATOR_H


template <class T> class CCalculator
{
        private:
        	T* (*mfCalc)(OnState st, T *, T *);
        	char *mMsgError;
        	TObjectX mType;
        public:
        	CCalculator();
        	CCalculator(CCalculator &cal);
        	CCalculator(TObjectX type, T* (*fcalc)(OnState st, T *, T *), char *err=0);
        	void SetTObject(TObjectX type);
        	void SetMsgError(char *err);
        	void SetfCalc(T* (*fcalc)(OnState st, T *, T *));
        	T *Evaluate(OnState st, T *objg, T *objd);
        	TObjectX GetTypeObject();
        	~CCalculator();
};



template <class T> CCalculator<T>::CCalculator()
{
        mMsgError = NULL;
        mfCalc = NULL;
        mType = TO_UNKNOWN;
}

template <class T> CCalculator<T>::CCalculator(CCalculator &cal)
{
        mfCalc = cal.mfCalc;
        if (cal.mMsgError)
        {
                mMsgError = new char[strlen(cal.mMsgError)+1];
                strcpy(mMsgError, cal.mMsgError);
        } else mMsgError = NULL;
        mType = cal.mType;
}

template <class T> CCalculator<T>::CCalculator(TObjectX type, T* (*fcalc)(OnState st, T *, T *), char *err)
{
        mType = type;
        if (err)
        {
                mMsgError = new char[strlen(err)+1];
                strcpy(mMsgError, err);
        } else mMsgError = NULL;
        mfCalc = fcalc;
}

template <class T> void CCalculator<T>::SetTObject(TObjectX type)
{
        mType = type;
}

template <class T> void CCalculator<T>::SetMsgError(char *err)
{
        if (err)
        {
                mMsgError = new char[strlen(err)+1];
                strcpy(mMsgError, err);
        } else mMsgError = NULL;
}

template <class T> void CCalculator<T>::SetfCalc(T* (*fcalc)(OnState st, T *, T *))
{
        mfCalc = fcalc;
}

template <class T> T* CCalculator<T>::Evaluate(OnState st, T *objg, T *objd)
{
        T *po = ((*mfCalc)(st, objg, objd));
        po->Type() = mType;
        return po;
}

template <class T> TObjectX CCalculator<T>::GetTypeObject()
{
        return mType;
}

template <class T> CCalculator<T>::~CCalculator()
{
        mfCalc = NULL;
        if (mMsgError) delete mMsgError;
        mMsgError = NULL;
        mType = TO_UNKNOWN;
}

#endif  /*  CCALCULATOR_H  */