#ifndef XMObjectX_H
#define XMObjectX_H
#include <stdio.h>
#include "type.h"
#include "chaine.h"
#include "Liste.h"

//////////////////////////////////////////////////////////////////////
XMObjectX *GetObjectX(char *name);////////////////////////////////////
XMObjectX *GetXMObjectX(char *name, CList<XMObjectX *> *list=NULL);///
//////////////////////////////////////////////////////////////////////

class XMObjectX
{
	private : void *mObjectX;
        protected:
        	//[0] <==> Expression interne
        	//[1] <==> Expression externe
        	char *mExpression[2], *mName;
        	CList <XMObjectX *> *mLVar;
        	TObjectX mType;
        public:
        	XMObjectX();
        	XMObjectX(XMObjectX &obj);
        	XMObjectX(XMObjectX *obj);
        	XMObjectX(char *expi, char *expe=NULL, char *nom=NULL);
        	//XMObjectX(char *expi, char *expe=NULL, char *nom=NULL, CList <XMObjectX *> *lvar);
        	void Set(char *expi, char *expe=NULL, char *nom=NULL);
        	void SetName(char *Name);
        	void SetExp(int k, char *exp); //k=0 <-> interne, k=1<-> externe
        	char *GetName();
        	char *GetExp(int k);

      	        int NVariables();        	
      	        void *Variables();
      	        void AddVariable(XMObjectX *obj);
      	        void AddVariables(CList <XMObjectX *> *lvar);
        	XMObjectX *Variable(int k);
        	XMObjectX *Variable(char *name);
        	
        	TObjectX &Type(){return mType;}
        	
        	void *&ObjectX(){return mObjectX;}// Assure la compatibilte avec SObjectX
        	
        	virtual char *Formatted()=0;
        	virtual TYPE  Eval(int &i, CList <XMObjectX *> *lvar=NULL)=0;
        	virtual char *EvalF(int &i, CList <XMObjectX *> *lvar=NULL)=0;
        	virtual XMObjectX *XEval(int &i, CList <XMObjectX *> *lvar=NULL)=0;
        	virtual XMObjectX *Diff(char *x)=0;
        	virtual XMObjectX *Clone()=0;
     	        virtual char *Affiche()=0;
        	virtual void  Lecture()=0;
		virtual ~XMObjectX();
};

#endif  /* XMObjectX_H */