#ifndef MOTOR3D_H
#define MOTOR3D_H
#include "vecteur.h"
#include "motor.h"

typedef struct CPoint;

class Motor3D: Motor
{
	TYPE  mTheta, mPhi;
	TYPE  mDistance;
	int * mOrg;
	int * mPtOfView;
	// La base
	TYPE * mI, *mJ, *mN;
public:
	Motor3D();
	Motor3D(int *Eye, int *org, TYPE distance, TYPE phi, TYPE theta);
	void Configure();
	void EvalXY(int &vld, TYPE *pt, TYPE *Res);
	int EvalX(int &vld, TYPE *pt);
	int EvalY(int &vld, TYPE *pt);

	void ConfigurerDist(double dist);
	void ConfigurerOrg(int org);
	void ConfigurerEye(int eye);
	void ConfigurerBase(TYPE phi, TYPE theta);
	double GetDist();
	int *GetOrg();
	int *GetEye(XMVecteur *eye);
	double GetBaseTheta();
	double GetBasePhi();
	void   GetI(TYPE *i);
	void   GetJ(TYPE *j);
	void   GetN(TYPE *n);
	void   GetBase(double *theta, double *phi);
	CPoint TroisDTo2D(XMVecteur M, bool *flag);
	virtual ~Motor3D();
};


#endif	/* MOTOR3D_H */