#include "plot.h"

void XMPlot::Add(XMObjectX *ob)
{
	switch (ob->Type())
	{
		case TO_INTERVALLE:
			if (!mSyscoord) mSyscoord = new SysCoord;
			mSyscoord->Add((XMIntervalle *)ob);
			break;
		case TO_SYSCOORD:
			mSyscoord = (SysCoord *)(ob);
			break;
		case TO_PLOTER:
			if (!mAPloter) mAPloter = new CList <XMPloter *>;
			mAPloter->Add((XMPloter *)ob);
			break;
		default:
			{
				XMPloter *plter;
				if (!mAPloter)
				{
					mAPloter = new CList <XMPloter *>;plter=new XMPloter(ob);
					mAPloter->Add(plter);
				} else mAPloter->MoveLast(plter);
				plter->Add(ob);
			}
	}
}

int XMPlot::Dim()
{
	int dim=2;
	XMPloter *plt;
	if (!mAPloter) return dim;
	for (mAPloter->MoveFirst(plt);!mAPloter->Eol();mAPloter->MoveNext(plt)) dim=(plt->Dim() <= 2?dim: plt->Dim());
	return dim;
}

XMPlot2D::XMPlot2D():XMPlot(TO_PLOT3D)
{
}

char *XMPlot2D::Formatted()
{
	char *formatted;
	
	formatted = new char[999999];
	printf("==============  Type:  %d   ================\n", mType);
	sprintf(formatted, "%d#%s#", mType, mName);
	return formatted;
}

XMMap* * XMPlot2D::Tracer(int ko=-1)
{
	if (!mAPloter) return NULL;
	//if (ko != -1) return (XMMap **)(&Map(mAPloter->Get(ko)));
	XMMap **map;
	int k=0;
	ko=mAPloter->GetCount();
	map = new (XMMap *)[ko+1];
	map[ko] = NULL;
	XMTRACE("Entrer de Tracer [%p] %d\n",mAPloter,ko);
	if (!mSyscoord) mSyscoord = mAPloter->Get(k)->Method()->DefaultAxis();
	for(k=0; k<ko; k++) map[k] = Map(mAPloter->Get(k));
	XMTRACE("Fin Map\n");
	return map;
}

XMMap * XMPlot2D::Map(XMPloter *plt)
{
	XMTRACE("Entrer dans Map [%p]:[%p]\n",Syscoord(),mAPloter);
	if (!plt) return 0;
	XMTRACE("Creation d'un Map\n");
	XMMap *map = new XMMap(plt->Dim());
	XMTRACE("Map\n");
	return (MapBis(map, plt, mAPloter->GetCount()) ? map: NULL);
}

int XMPlot::MapBis(XMMap *map, XMPloter *plt, int num)
{

	if (!plt) return 0;
	XMTRACE("Syscoord d'un Map  %p\n",mSyscoord);
	if (!plt->Intervalles()) return (int)(map=(XMMap *)(plt->Map((CList <XMObjectX *>*)(mSyscoord?mSyscoord->Intervalles():NULL))));
	XMIntervalle *in;
	if (!(in = plt->Intervalles()->Get(num))) return 0;
	while (in->IsValid())
	{
		if (!num) MapBis(map, plt, num-1); else
		//map->Add(plt->Reach(plt->Intervalles(), mSyscoord->Intervalles()));
		in->Inc();
	}
	in->Init();
	return 1;
}

void  XMPlot::Lecture()
{
	XMTRACE("============ Lecture de l'objet XMPlot ============\n");
	if (mSyscoord) XMTRACE("Syscoord:\n"); else XMTRACE("Aucun systeme de coordonnees defini\n");
	if (mAPloter)
	{
		XMTRACE("Nbre d'objet a tracer: %d\n",mAPloter->GetCount());
		XMPloter *plt;
		for (mAPloter->MoveFirst(plt);!mAPloter->Eol();mAPloter->MoveNext(plt)) plt->Lecture();
	} else XMTRACE("Aucun objet a tracer\n");
	XMTRACE("===================================\n");
}
/*
XMPlot3D::XMPlot3D():XMPlot(TO_PLOT3D)
{
}*/

XMMap ** XMPlot3D::Tracer(int k=-1)
{
	return NULL;
}

XMMap  * XMPlot3D::Map(XMPloter *plt)
{
	return NULL;
}