#include <stdio.h>
#include "utils.h"
#include "chaine.h"
#include "type.h"


SObjectX* MakeObjectXFromStree(STree *st)
{
        SObjectX *obj;
        obj = new SObjectX;
        obj->Nom  = st->Nom;
        obj->Type() = ConvertToTObjectX((TOperator)st->mType);
        obj->ObjX = (void *)st->Nom;
}

TOperator IsKeyWord(char *exp)
{
	for (int i=0;XM_KEYWORD[i]; i++) if (!strcmp(XM_KEYWORD[i], exp)) return TNSOP_COMM;
	return TOP_UNKNOWN;
}

TOperator IsSimpleOperator(char op)
{
        switch (op)
        {
                case ')': return TOP_PARENTHESEF;
                case '(': return TOP_PARENTHESEO;
                case '+': return TOP_PLUS;
                case '-': return TOP_MOINS;
                case '*': return TOP_MULTIPLIE;
                case '/': return TOP_DIVISE;
                case '^': return TOP_PWD;
                case ',': return TOP_VIRGULE;
                case '[': return TOP_CROCHETO;
                case ']': return TOP_CROCHETF;
                case '{': return TOP_WHOLE;
                case '}': return TOP_WHOLE;
                case '=': return TOP_EGAL;
                default: return TOP_UNKNOWN;
        }
}

void Decompress(char *ss, char **sd)
{
        int  i=0;
        
        (*sd) = NULL;
        if (ss[i] == ')') Set(sd, ")"); else 
        if (ss[i] == '(') Set(sd, "("); else 
        if (ss[i] == '+') Set(sd, "+"); else
        if (ss[i] == '-') Set(sd, "-"); else
        if (ss[i] == '*') Set(sd, "*"); else
        if (ss[i] == '/') Set(sd, "/"); else
        if (ss[i] == '^') Set(sd, "^"); else
        if (ss[i] == ',') Set(sd, ","); else
        if (ss[i] == '[') Set(sd, "["); else
        if (ss[i] == ']') Set(sd, "]"); else
        if (ss[i] == '{') Set(sd, "{"); else
        if (ss[i] == '}') Set(sd, "}"); else
        if (ss[i] == '=') Set(sd, "="); else
	if ((ss[i] == '.') && (ss[i+1] == '.')) Set(sd, ".."); else
        {
                (*sd) = new char[strlen(ss)+1];
        	if ((ss[i]>=48) && (ss[i]<=57))
        	{
        	        int exe=0;
          	     	while (1)
         	    	{
         	    	 	if ((ss[i]>=48) && (ss[i]<=57))
              	 	        {
               		               	(*sd)[i]=ss[i]; i++;
               	 	              	if(ss[i]=='.')
               	  	     	 	{
               	  	     	 		(*sd)[i]='.'; i++;
               	  	     	 		if (ss[i]=='.') {i--;break;}               	  	     	 		
               	    	    	        }
               	         	} else break;
               	        } (*sd)[i]='\0';    // Manque un test if exe ...

               	} else
        	{
        	       	for (;(((EstDansAZaz(ss[i])) || ((ss[i]>=48) && (ss[i]<=57))) && (ss[i]));i++) (*sd)[i]=ss[i];
			(*sd)[i]='\0';
		}
        }
        if (*sd) Decallage(strlen(*sd), ss);
}

TOperator GetTNSOperator(char *op)
{
        if (!strcmp(op, "det"))		return TNSOP_DET;
        if (!strcmp(op, "mat"))		return TNSOP_MAT;
        if (!strcmp(op, "diff"))	return TNSOP_DIFF;
        if (!strcmp(op, "eval"))	return TNSOP_EVAL;
        if (!strcmp(op, "plot"))	return TNSOP_PLOT;
        if (!strcmp(op, "evalf"))	return TNSOP_EVALF;
        if (!strcmp(op, "test"))	return TNSOP_TEST;
        return TOP_UNKNOWN;
}

TOperator GetTSOperator(char *op)
{
	if (!strcmp(op,".."))		return TOP_INTERVALLE;
        if (!strcmp(op,"cos"))		return TOP_TRIGO;
        if (!strcmp(op,"sin"))		return TOP_TRIGO;
        if (!strcmp(op,"tan")) 		return TOP_TRIGO;
        if (!strcmp(op,"abs")) 		return TOP_ABS;
        if (!strcmp(op,"exp")) 		return TOP_EXP;
        if (!strcmp(op,"ln"))  		return TOP_LN;
        if (!strcmp(op,"ch"))  		return TOP_HYPER;
        if (!strcmp(op,"sh"))		return TOP_HYPER;
        if (!strcmp(op,"th"))  		return TOP_HYPER;
        if (!strcmp(op,"sqrt"))		return TOP_PWD;
        if (!strcmp(op,"argch"))	return TOP_HYPER;
        if (!strcmp(op,"argth"))	return TOP_HYPER;
        if (!strcmp(op,"argsh"))	return TOP_HYPER;
        if (!strcmp(op,"arctan"))	return TOP_TRIGO;
        return TOP_UNKNOWN;
}

char *GetGroupOf(TOperator op)
{
	switch(op)
        {
                case TOP_ABS:		return "Fonction";
                case TOP_EXP:		return "Exponentielle";
                case TOP_HYPER:		return "Hyperbolique";
                case TOP_TRIGO:		return "Trigonomtrique";
                default:  		return "Inconnu!!!";
        }
}

char *GetCharOf(TOperator op)
{
        switch(op)
        {
                case TOP_ABS:		return "Valeur obsolue";
                case TOP_EXP:		return "Exponentielle";
                case TOP_HYPER:		return "Hyperbolique";
                case TOP_MOINS:		return "Moins";
                case TOP_PARENTHESEF:	return "Parenthese fermante";
                case TOP_PARENTHESEO:	return "Parenthese ouvrante";
                case TOP_PLUS:		return "Plus";
                case TOP_TRIGO:		return "Trigonomtrique";
                case TOP_VARIABLE:	return "Variable";
                case TOP_INTERVALLE:	return "Intervalle ..";
                case TNSOP_MAT:		return "Matrice";
		case TNSOP_PLOT:	return "Plot";
                default:  		return "Inconnu!!!";
        }
}


TObjectX ConvertToTObjectX(TOperator op)
{
        if ((int)(op)<=(int)(TO_UNKNOWN)) return (TObjectX)op;
        switch(op)
        {
                case TOP_ABS:		return TO_UNKNOWN;
		case TOP_CROCHETF:	return TO_UNKNOWN;
		case TOP_CROCHETO:	return TO_UNKNOWN;
        	case TOP_DIVISE:	return TO_UNKNOWN;
        	case TOP_EGAL:		return TO_UNKNOWN;
        	case TOP_EXP:		return TO_UNKNOWN;
        	case TOP_HYPER:		return TO_UNKNOWN;
        	case TOP_LN:		return TO_UNKNOWN;
        	case TOP_MOINS:		return TO_UNKNOWN;
        	case TOP_MULTIPLIE:	return TO_UNKNOWN;
        	case TOP_PARENTHESEF:	return TO_UNKNOWN;
        	case TOP_PARENTHESEO:	return TO_UNKNOWN;
        	case TOP_PLUS:		return TO_UNKNOWN;
        	case TOP_PWD:		return TO_UNKNOWN;
        	case TOP_TRIGO:		return TO_UNKNOWN;
        	case TOP_VARIABLE:	return TO_VARIABLE;
        	case TOP_VIRGULE:	return TO_WHOLE;
        	case TOP_INTERVALLE:	return TO_INTERVALLE;
        
        	case TNSOP_DET:		return TO_UNKNOWN;
        	case TNSOP_DIFF:	return TO_UNKNOWN;
        	case TNSOP_EVAL:	return TO_UNKNOWN;
        	case TNSOP_PLOT:	return TO_PLOT;
        	case TNSOP_EVALF:	return TO_UNKNOWN;
        	case TNSOP_MAT:		return TO_MATRICE;
        	case TNSOP_TEST:	return TO_UNKNOWN;
        
        	case TNSOP_COMM:	return TO_KEYWORD;
        	default:		return TO_UNKNOWN;
        }
}

TObjectX DelimitToTObjectX(char *op)
{
	if (!strcmp(op, "[")) return TO_VECTEUR;
	if (!strcmp(op, "{")) return TO_WHOLE;
	if (!strcmp(op, "(")) return TO_INIT;
	return TO_INIT;
}

char *GetGroupeName(TObjectX type)
{
	switch (type)
	{
		case TO_FONCTION: 	return "Fonction";
        	case TO_VECTEUR: 	return "Vecteur";
        	case TO_MATRICE: 	return "Matrice";
        	case TO_VARIABLE: 	return "Variable";
        	case TO_POLYNOME: 	return "Plynome";
        	case TO_INTERVALLE: 	return "Intervalle";
        	case TO_PLOT: 		return "Graphe";
        	case TO_PLOTER: 	return "Srie de points";
        	case TO_SYSCOORD: 	return "Systme de coordonnes";
        	case TO_PLOT2D: 	return "Graphe 2D";
        	case TO_PLOT3D: 	return "Graphe 3D";
        	case TO_SCRIPT: 	return "Script systme";
       	 	case TO_KEYWORD: 	return "Mots cls";
        	case TO_WHOLE: 		return "Ensemble";
        	case TO_HEAD: 		return "Dfinisseur";
        	case TO_INIT: 		return "Vide";
        	case TO_UNKNOWN: 	return "Inconnue";
        	default:		return "Inconnue";
	}
}