#ifndef CLIENT_COMMUNICATION_H
#define CLIENT_COMMUNICATION_H

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <XMProtocol.h>
#include <pthread.h>

class HandleServer;

SCConnection *ConnectToServer(char *adresse);
int SendToServer(SCConnection * con, XMQuery *query);
int ListenToServer(SCConnection * con, int status, HandleServer *hdle);
XMReponse * ReceiveFromServer(SCConnection * con);
int DisconnectToServer(SCConnection * con);
int ShutdownServer(SCConnection * con);

XMQuery *InitQuery(XMQuery *query);
XMQuery *MakeQuery(XMQuery *query, int id_client, int id_query, char *data);
int 	 ReadReponse(XMReponse *reponse, int &id_client, int &id_query, char *data);

void SetThreadWait(double pause);

class HandleServer
{
	public : virtual void TreateReponse(XMReponse *reponse)=0;
};

#endif  /* XMCORE_H */