//=======================================
#ifndef _MEMORY_h
//====== put your code below here =======
#define _MEMORY_h

#include <vdk/dlist.h>

template <class X, class T> class Memory: public VDKList<T>
{
	int mMaxi;
	int mCompter;
public:
	Memory(){mCompter = 0; mMaxi = -1;};
	Memory(int maxi = -1){mCompter = 0; mMaxi = maxi;};
	void add(T *t);
	int remove(T* x);
	void flush();
	T *get(int i);
	T *find(char *name);
	~Memory(){};
};

template <class X, class T> void Memory<X, T>::add(T *t)
{
	if ((mMaxi>0) && (mCompter>mMaxi)) return;
	mCompter++;
	VDKList<T>::add(t);
}

template <class X, class T> int Memory<X, T>::remove(T* x)
{
	mCompter--;
	return (VDKList<T>::remove(t));
}

template <class X, class T> void Memory<X, T>::flush()
{
	mCompter = 0;
	VDKList<T>::flush();
}

template <class X, class T> T *Memory<X, T>::get(int i)
{
	
	return (((size()==0) || (i>=size()) || (i<0))?0:VDKList<T>::operator[](i));
}

template <class X, class T> T *Memory<X, T>::find(char *name)
{
	T* Result = 0;
	int n = size();
	for (int i=0; (!Result) && (i<n); i++)
		if (!strcmp((Result=VDKList<T>::operator[](i))->GetName(), name)) Result = 0;
	return Result;
}

//=======================================
#endif
