#! /bin/sh
#########################################
#		Setup.sh		#
#					#
#########################################

## Initialisation des constantes ########
EASYMATHS_NAME=EasyMaths
NOM_OUTIL=`basename $0`
FICHIER_MODULE="MODULE"
PROG_SH_VERSION="Version.sh"
PROG_SH_EASYMATHS_CONFIG="Easymaths-config.sh"
FICHIER_CONFIG_SETUP="Setup.conf"
FICHIER_LOG_SETUP="Setup.log"
#########################################


function ArrangeBackslash ( )
{
	CHAINE_A_ARRANGER=$1
	CHAINE_ARRANGEE=""
	POSITION=0
	TAILLE=`expr length $CHAINE_A_ARRANGER`
	while [ $POSITION -le $TAILLE ];
	do
		CARAC=`expr substr $CHAINE_A_ARRANGER $POSITION 1`
		if [ "$CARAC" = "/" ]; then
			CARAC="\/"
		fi
		CHAINE_ARRANGEE="$CHAINE_ARRANGEE$CARAC"
		POSITION=`expr $POSITION + 1`
	done
}

function ActionSed ( )
{
	mv $1 $1.sav
	ArrangeBackslash "$2"
	A_CHERCHER="$CHAINE_ARRANGEE"
	ArrangeBackslash "$3"
	A_METTRE="$CHAINE_ARRANGEE"
	sed s/$A_CHERCHER/$A_METTRE/g $1.sav >$1
	rm $1.sav
}

#Fonction renvoyant le chemin absolu d'un rpertoire
function AbsoluteDir( )
{
	Name_Dir=$1
	cd $Name_Dir
	ABSOLUTE_DIR=`pwd`
	cd -
	return 0 #\"$AbsolteName\"
}
###########################################################################################################################
###########################################################################################################################

function EtablirConfigurationBasic ( )
{
	EASYMATHS_HOME=`pwd`	
}
#########################################

#Parametres de configuration ############
function EtablirLaConfiguration ( )
{
	echo "=========  Configuration  =========="
	echo "Recherche de la library vdk"
	VDK_FOUND=`whereis vdk-config`
	VDK_HOME=`echo $VDK_HOME | cut -d: -f2`

	if [ $VDK_HOME  ]; then
		echo "Veuillez installer tout d'abord la librairy vdk"
		echo "Vous pouvez le downloader et effectuer sur recherche sur 'www.freshmeat.net'"
		exit 0
	fi
	echo "Library vdk...Ok"
	
	echo "Entrer votre compilateur [g++]."
	read REPONSE
	if [ X"$REPONSE" != X ]; then
		COMPILER=$REPONSE
	else
		COMPILER="g++"
	fi

	echo "Entrer le rpertoire o vous voulez installer les libraries [$EASYMATHS_HOME/lib]."
	read REPONSE
	if [ X"$REPONSE" != X ]; then
		AbsoluteDir $REPONSE
		IHM_LIB_DIRECTORY="$ABSOLUTE_DIR"
		CORE_LIB_DIRECTORY="$ABSOLUTE_DIR"
	else
		IHM_LIB_DIRECTORY="$EASYMATHS_HOME/lib"
		CORE_LIB_DIRECTORY="$EASYMATHS_HOME/lib"
	fi
	
	echo "Entrer le rpertoire o vous voulez installer les binaries [$EASYMATHS_HOME/bin]."
	read REPONSE
	if [ X"$REPONSE" != X ]; then
		AbsoluteDir $REPONSE
		IHM_BIN_DIRECTORY="$ABSOLUTE_DIR"
		CORE_BIN_DIRECTORY="$ABSOLUTE_DIR"
	else
		IHM_BIN_DIRECTORY="$EASYMATHS_HOME/bin"
		CORE_BIN_DIRECTORY="$EASYMATHS_HOME/bin"
	fi
	echo "Veuillez patienter. Configuration en cours..."
}
#########################################


#Parametres de configuration ############
function CreerFichierDeConfig ( )
{
	#Cration du fichier setup.conf
	CHEMIN_FICHIER_CONFIG_SETUP="$EASYMATHS_HOME/$EASYMATHS_NAME/$FICHIER_CONFIG_SETUP"
	cat <<FIN >"$CHEMIN_FICHIER_CONFIG_SETUP"
#########################################
#	Fichier de configuration	#
#	  de l'installation de		#
#		EasyMaths		#
#########################################
EASYMATHS_NAME=$EASYMATHS_NAME
EASYMATHS_HOME=$EASYMATHS_HOME
PROG_SH_VERSION=$EASYMATHS_HOME/$EASYMATHS_NAME/$PROG_SH_VERSION
EASYMATHS_FICHIER_CONFIG=$EASYMATHS_HOME/config/$EASYMATHS_NAME.conf
EASYMATHS_VERSION=`$EASYMATHS_HOME/$EASYMATHS_NAME/$PROG_SH_VERSION -current`
FLUX_DIR=$EASYMATHS_HOME/flux
IHM_LIB_INSTALL_DIR=$IHM_LIB_DIRECTORY
IHM_LIB_SOURCE_DIR=$EASYMATHS_HOME/$EASYMATHS_NAME/IHM
IHM_BIN_INSTALL_DIR=$IHM_BIN_DIRECTORY
IHM_BIN_SOURCE_DIR=$EASYMATHS_HOME/$EASYMATHS_NAME/IHM
CORE_LIB_INSTALL_DIR=$CORE_LIB_DIRECTORY
CORE_LIB_SOURCE_DIR=$EASYMATHS_HOME/$EASYMATHS_NAME/Core
CORE_BIN_INSTALL_DIR=$CORE_BIN_DIRECTORY
CORE_BIN_SOURCE_DIR=$EASYMATHS_HOME/$EASYMATHS_NAME/Core
COMPILER=$COMPILER
FIN
}
#########################################


#Parametres de configuration ############
function CreerFichierLog ( )
{
	CHEMIN_FICHIER_LOG_SETUP="$EASYMATHS_HOME/$FICHIER_LOG_SETUP"
	cat<<FIN >"$CHEMIN_FICHIER_LOG_SETUP"
#################################
# Fichier Log de l'installation	#
# de EasyMaths			#
#################################

FIN
}
#########################################


#Parametres de configuration ############
function ConfigurerFichiersTag ( )
{
	RepertoireATraiter="$EASYMATHS_HOME/$EASYMATHS_NAME/Core $EASYMATHS_HOME/$EASYMATHS_NAME/IHM $EASYMATHS_HOME/config $EASYMATHS_HOME/sh"
	for Repertoire in $RepertoireATraiter;
	do
		cd "$Repertoire"
		for FICHIER_TAG in `ls -1 *+tag 2>/dev/null`;
		do
			cp -f "$FICHIER_TAG" ".$FICHIER_TAG"
			while [ `grep % $FICHIER_TAG|wc -l` != 0 ];
			do
				NOM_TAG=`grep "%" $FICHIER_TAG|head -1|cut -d% -f2`
				VALEUR_TAG=`grep "^$NOM_TAG=" "$CHEMIN_FICHIER_CONFIG_SETUP"|cut -d= -f2`
				if [ X"$VALEUR_TAG" != X ];then
					ActionSed "$FICHIER_TAG" "%$NOM_TAG%" "$VALEUR_TAG"
				else
					echo "Parametre $NOM_TAG nom trouv dans le fichier de"
					echo "configuration de l'installation"
					echo "Le fichier de configuration de l'installation est peut"
					echo "tre corrompu!!! Veuillez recommencer l'installation."
					exit 1
				fi				
			done
			NOM_FICHIER=`echo "$FICHIER_TAG"|cut -d"+" -f1`
			mv "$FICHIER_TAG" "$NOM_FICHIER"
		done
		cd -
	done
}
#########################################


#Parametres de configuration ############
function EntrerDansEasyMaths ( )
{
	REP_AVANT_ENTRER=`pwd`
	cd "$EASYMATHS_HOME/$EASYMATHS_NAME"
}
#########################################


#Attribution des droits #################
function AttribuerDroits ( )
{
	chmod 400 "$FICHIER_MODULE"
	chmod 511 "$PROG_SH_EASYMATHS_CONFIG"
	chmod 511 "$PROG_SH_VERSION"
	chmod -R 511 "$EASYMATHS_HOME/sh"
}
#########################################


#Attribution des droits #################
function ChercherConfigurationCore ( )
{
	CORE_LISTE_LIBRAIRIES=`cat "$EASYMATHS_HOME/$EASYMATHS_NAME/$FICHIER_MODULE"|grep cor|grep lib|cut -d: -f7|sed s/"%"//g|sed s/".so"//g`
	CORE_LIBRAIRIES_DIR="-L"`grep IHM_LIB_INSTALL_DIR "$CHEMIN_FICHIER_CONFIG_SETUP"|cut -d= -f2`
	for LIBRAIRY in $CORE_LISTE_LIBRAIRIES; do
		Taille=`expr length $LIBRAIRY`
		Taille=`expr $Taille - 2`
		LIBRAIRY=`expr substr $LIBRAIRY 4 $Taille`
		CORE_LIBRAIRIES="$IHM_LIBRAIRIES -l$LIBRAIRY"
	done
	CORE_INCLUDES_DIR=-I`grep CORE_LIB_SOURCE_DIR "$CHEMIN_FICHIER_CONFIG_SETUP"|cut -d= -f2`
}
#########################################


#Attribution des droits #################
function ChercherConfigurationIHM ( )
{
	IHM_LISTE_LIBRAIRIES=`cat "$EASYMATHS_HOME/$EASYMATHS_NAME/$FICHIER_MODULE"|grep ihm|grep lib|cut -d: -f7|sed s/"%"//g|sed s/".so"//g`
	IHM_LIBRAIRIES_DIR="-L"`grep IHM_LIB_INSTALL_DIR "$CHEMIN_FICHIER_CONFIG_SETUP"|cut -d= -f2`
	for LIBRAIRY in $IHM_LISTE_LIBRAIRIES; do
		Taille=`expr length $LIBRAIRY`
		Taille=`expr $Taille - 2`
		LIBRAIRY=`expr substr $LIBRAIRY 4 $Taille`
		IHM_LIBRAIRIES="$IHM_LIBRAIRIES -l$LIBRAIRY"
	done
	IHM_INCLUDES_DIR=-I`grep IHM_LIB_SOURCE_DIR "$CHEMIN_FICHIER_CONFIG_SETUP"|cut -d= -f2`
}
#########################################


#Attribution des droits #################
function CompleterFichierConfig ( )
{
	cat<<FIN >>"$CHEMIN_FICHIER_CONFIG_SETUP"
IHM_LIBRAIRIES_DIR=$IHM_LIBRAIRIES_DIR
IHM_INCLUDES_DIR=$IHM_INCLUDES_DIR
IHM_LIBRAIRIES=$IHM_LIBRAIRIES
CORE_LIBRAIRIES=$CORE_LIBRAIRIES_DIR
CORE_INCLUDES_DIR=$CORE_INCLUDES_DIR
CORE_LIBRAIRIES=$CORE_LIBRAIRIES
FIN
}
#########################################


#Attribution des droits #################
function GenererEtInstallerCore ( )
{
	cd Core
	echo >> "$CHEMIN_FICHIER_LOG_SETUP"
	echo "# Compilation du noyau de EasyMaths" >> "$CHEMIN_FICHIER_LOG_SETUP"
	echo >> "$CHEMIN_FICHIER_LOG_SETUP"
	echo " Installation du serveur en cours. Patientez ..."
	make make_all 2>> "$CHEMIN_FICHIER_LOG_SETUP">> "$CHEMIN_FICHIER_LOG_SETUP"
	if [ $? = 0 ]; then
		echo
		echo " Compilation du noyau de $EASYMATHS_NAME ralis avec succes"
		echo
	else
		echo
		echo " La compilation du noyau de $EASYMATHS_NAME s'est terminer avec des erreurs"
		echo " Consulter le fichier $FICHIER_LOG_SETUP pour en savoir plus."
		echo " Voulez-vous continuer ([o]/n)?"
		read REPONSE
		if [ x"$REPONSE" = xn ]; then
			echo
			echo "Abandon de l'installation de $EASYMATHS_NAME!!!"
			echo
			exit 0
		fi
	fi
	cd -
}
#########################################


#Attribution des droits #################
function GenererEtInstallerIHM ( )
{
	cd IHM
	echo >> "$CHEMIN_FICHIER_LOG_SETUP"
	echo "# Compilation de l'IHM de EasyMaths" >> "$CHEMIN_FICHIER_LOG_SETUP"
	echo >> "$CHEMIN_FICHIER_LOG_SETUP"
	echo " Installation de l'interface graphique du serveur en cours. Patientez ..."
	make make_all 2>> "$CHEMIN_FICHIER_LOG_SETUP">> "$CHEMIN_FICHIER_LOG_SETUP"
	if [ $? = 0 ]; then
		echo
		echo " Compilation de l'IHM de $EASYMATHS_NAME ralis avec succes"
		echo
	else
		echo
		echo " La compilation de l'IHM de $EASYMATHS_NAME s'est terminer avec des erreurs"
		echo " Consulter le fichier $FICHIER_LOG_SETUP pour en savoir plus."
		echo " Voulez-vous continuer ([o]/n)?"
		read REPONSE
		if [ x"$REPONSE" = xn ]; then
			echo
			echo "Abandon de l'installation de $EASYMATHS_NAME!!!"
			echo
			exit 0
		fi
	fi
	cd -
}
#########################################


#Attribution des droits #################
function MettreAJourFichierProfile ( )
{
	FICHIER_PROFILE="$1"
	if [ -f $FICHIER_PROFILE ]; then
		echo
		echo "Mise  jour de la variable PATH dans votre fichier profile [$FICHIER_PROFILE]"
		echo
		LIGNE=`grep ^PATH= $FICHIER_PROFILE`
		BIN_DIR=`$EASYMATHS_HOME/$EASYMATHS_NAME/$PROG_SH_EASYMATHS_CONFIG -hm`/bin
		DEJA_FAIT=X`echo $LIGNE|grep "$BIN_DIR"`
		if [ $DEJA_FAIT != X ]; then
			return
		fi
		NOUVELLE_LIGNE=$LIGNE:$BIN_DIR
		ActionSed "$FICHIER_PROFILE" "$LIGNE" "$NOUVELLE_LIGNE"
	
		echo
		echo "Mise  jour de la variable LD_LIBRARY_PATH dans votre fichier profile [$FICHIER_PROFILE]"
		echo
		LIGNE=`grep ^LD_LIBRARY_PATH= $FICHIER_PROFILE`
		LIB_DIR=`$EASYMATHS_HOME/$EASYMATHS_NAME/$PROG_SH_EASYMATHS_CONFIG -hm`/lib
		DEJA_FAIT=X`echo $LIGNE|grep "$LIB_DIR"`
		if [ $DEJA_FAIT != X ]; then
			return
		fi
		NOUVELLE_LIGNE=$LIGNE:$LIB_DIR
		ActionSed "$FICHIER_PROFILE" "$LIGNE" "$NOUVELLE_LIGNE"
		chmod 755 "$FICHIER_PROFILE"
		. "$FICHIER_PROFILE"
	fi
}
#########################################


#Attribution des droits #################
function SortirDeEasyMaths ( )
{
	cd "$REP_AVANT_ENTRER"
}
#########################################


#Attribution des droits #################
function AfficherInformationFin ( )
{
	cat << FIN
L'installation de $EASYMATHS_NAME s'est termine sans erreur. Youppi!!!!
Pour prendre en compte les nouvelles donnes d'environnement, veuillez excuter la commande
suivante: . \$HOME/.bash_profile

Ensuite lancer :
	o le serveur XMCoreServer en executant le shell XMCoreServer.sh contenu dans le rpertoire sh.
	o l'IHM de $EASYMATHS_NAME en excutant le shell $EASYMATHS_NAME.sh situ dans le rpertoire sh.
FIN
}
#########################################


#Attribution des droits #################
function ProcedurePrincipale ( )
{
	EtablirConfigurationBasic
	EntrerDansEasyMaths
	EtablirLaConfiguration
	CreerFichierDeConfig
	CreerFichierLog
	ConfigurerFichiersTag
	AttribuerDroits
	ChercherConfigurationCore
	ChercherConfigurationIHM
	CompleterFichierConfig
	GenererEtInstallerCore
	GenererEtInstallerIHM
	MettreAJourFichierProfile "$HOME/.bash_profile"
	SortirDeEasyMaths
	if [ $? != 0 ]; then
		echo
		echo "L'installation s'est termine avec des erreurs"
		echo "Veuillez ressayer  nouveau, si des erreurs apparassent  nouveau contacter l'auteur"
		echo "	Didier.Daville@LibertySurf.fr"
		echo
	else
		echo
		AfficherInformationFin
		echo
	fi
}
#########################################


#########################################
ProcedurePrincipale #####################
#########################################